#include <stdio.h>

#define BSIZE 2048
#define LETTERS 28

char buf[BSIZE];
int sous[LETTERS][LETTERS];
char pres[LETTERS];

void parse_inp(void)
{
  int N, len;

  gets(buf);
  sscanf(buf, "%d", &N);
  while (N--) {
    gets(buf);
    len = strlen(buf);
    pres[((int)buf[0])-'a'] = 1;
    pres[((int)buf[len-1])-'a'] = 1; 
    sous[((int)buf[0])-'a'][((int)buf[len-1])-'a']++;
  }
}

int start, end;

int can_deg(void)
{
  int odegs[LETTERS], idegs[LETTERS];
  int i, j;

  start = end = -1;
  memset(idegs, 0, sizeof(idegs));
  memset(odegs, 0, sizeof(odegs));
  for (i = 0; i < LETTERS; i++)
    for (j = 0; j < LETTERS; j++)
      if (sous[i][j]) {
        odegs[i] += sous[i][j]; idegs[j] += sous[i][j];
      }
  for (i = 0; i < LETTERS; i++) {
    if (idegs[i] != odegs[i])
      if (odegs[i] - idegs[i] == 1) {
        if (start != -1)
          return 0;
        start = i;
      }
      else if (odegs[i] - idegs[i] == -1) {
        if (end != -1)
          return 0;
        end = i;
      }
      else
        return 0;
  }
  return ((start != -1) && (end != -1)) || ((start == -1) && (end == -1));
}

void search(int v)
{
  int i;

  pres[v] = 2;
  for (i = 0; i < LETTERS; i++)
    if (sous[v][i] && pres[i] == 1)
      search(i);
}

int is_comp(void)
{
  int i;

  if (start == -1)
    for (start = 0; !pres[start]; start++);
  search(start);
  for (i = 0; i < LETTERS && (!pres[i] || pres[i] == 2); i++);
  if (i < LETTERS)
    return 0;
  return 1;
}

int main(void)
{
  int K;

  gets(buf);
  sscanf(buf, "%d", &K);
  while (K--) {
    memset(sous, 0, sizeof(sous));
    memset(pres, 0, sizeof(pres));
    parse_inp();
 
    if (can_deg() && is_comp())
      puts("Ordering is possible.");
    else
      puts("The door cannot be opened.");
  }
  return 0;
}

